local K, _, L = unpack(KkthnxUI)
local Module = K:GetModule("AurasTable")

local list = {
	["Enchant Aura"] = {
		{ AuraID = 341260, UnitID = "player", Flash = true },
		{ AuraID = 354808, UnitID = "player" },

		{ AuraID = 26297, UnitID = "player" },
		{ AuraID = 20572, UnitID = "player" },
		{ AuraID = 33697, UnitID = "player" },
		{ AuraID = 292463, UnitID = "player" },

		{ AuraID = 307159, UnitID = "player" },
		{ AuraID = 307162, UnitID = "player" },
		{ AuraID = 307163, UnitID = "player" },
		{ AuraID = 307164, UnitID = "player" },
		{ AuraID = 307494, UnitID = "player" },
		{ AuraID = 307495, UnitID = "player" },
		{ AuraID = 307496, UnitID = "player" },
		{ AuraID = 307497, UnitID = "player" },
		{ AuraID = 344314, UnitID = "player" },
		{ AuraID = 307195, UnitID = "player" },
		{ AuraID = 342890, UnitID = "player" },
		{ AuraID = 322302, UnitID = "player" },
		{ AuraID = 307160, UnitID = "player" },

		{ AuraID = 344231, UnitID = "player" },
		{ AuraID = 345228, UnitID = "player" },
		{ AuraID = 344662, UnitID = "player" },
		{ AuraID = 345439, UnitID = "player" },
		{ AuraID = 345019, UnitID = "player" },
		{ AuraID = 345530, UnitID = "player" },
		{ AuraID = 345541, UnitID = "player" },
		{ AuraID = 336588, UnitID = "player" },
		{ AuraID = 348139, UnitID = "player" },
		{ AuraID = 311444, UnitID = "player", Value = true },
		{ AuraID = 336465, UnitID = "player", Value = true },
		{ AuraID = 330366, UnitID = "player", Text = L["Crit"] },
		{ AuraID = 330367, UnitID = "player", Text = L["Versa"] },
		{ AuraID = 330368, UnitID = "player", Text = L["Haste"] },
		{ AuraID = 330380, UnitID = "player", Text = L["Mastery"] },
		{ AuraID = 351872, UnitID = "player" },
		{ AuraID = 355316, UnitID = "player" },
		{ AuraID = 356326, UnitID = "player" },
		{ AuraID = 355333, UnitID = "player" },
		{ AuraID = 357185, UnitID = "player" },
		{ AuraID = 357773, UnitID = "player" },
		{ AuraID = 165485, UnitID = "player" },
		{ AuraID = 165534, UnitID = "player" },
		{ AuraID = 230152, UnitID = "player" },

		{ AuraID = 367241, UnitID = "player" },
		{ AuraID = 363522, UnitID = "player" },
		{ AuraID = 362699, UnitID = "player" },
		{ AuraID = 345231, UnitID = "player" },
		{ AuraID = 368641, UnitID = "player" },

		{ AuraID = 381476, UnitID = "player" },
		{ AuraID = 383941, UnitID = "player" },

		{ AuraID = 331937, UnitID = "player", Flash = true },
		{ AuraID = 354053, UnitID = "player", Flash = true, Text = L["Crit"] },
		{ AuraID = 354054, UnitID = "player", Flash = true, Text = L["Versa"] },
		{ AuraID = 323546, UnitID = "player" },
		{ AuraID = 326860, UnitID = "player" },
		{ AuraID = 310143, UnitID = "player", Combat = true },
		{ AuraID = 327104, UnitID = "player" },
		{ AuraID = 327710, UnitID = "player" },
		{ AuraID = 328933, UnitID = "player" },
		{ AuraID = 328281, UnitID = "player" },
		{ AuraID = 328282, UnitID = "player" },
		{ AuraID = 328620, UnitID = "player" },
		{ AuraID = 328622, UnitID = "player" },
		{ AuraID = 324867, UnitID = "player", Value = true },
		{ AuraID = 328204, UnitID = "player" },
		{ AuraID = 325748, UnitID = "player" },
		{ AuraID = 315443, UnitID = "player" },
		{ AuraID = 325299, UnitID = "player" },
		{ AuraID = 327164, UnitID = "player" },
		{ AuraID = 325216, UnitID = "player" },
		{ AuraID = 343672, UnitID = "player" },
		{ AuraID = 324220, UnitID = "player" },
		{ AuraID = 311648, UnitID = "player" },
		{ AuraID = 323558, UnitID = "player" },
		{ AuraID = 323559, UnitID = "player" },
		{ AuraID = 323560, UnitID = "player" },
		{ AuraID = 338142, UnitID = "player" },
		{ AuraID = 310454, UnitID = "player" },
		{ AuraID = 325013, UnitID = "player" },
		{ AuraID = 308495, UnitID = "player" },
		{ AuraID = 328908, UnitID = "player" },
		{ AuraID = 345499, UnitID = "player" },
		{ AuraID = 339461, UnitID = "player" },
		{ AuraID = 325381, UnitID = "player", Flash = true },
		{ AuraID = 351414, UnitID = "player", Flash = true },
		{ AuraID = 342774, UnitID = "player" },
		{ AuraID = 333218, UnitID = "player" },
		{ AuraID = 336885, UnitID = "player" },
		{ AuraID = 324156, UnitID = "player", Flash = true },

		{ AuraID = 333961, UnitID = "player" },
		{ AuraID = 333943, UnitID = "player" },
		{ AuraID = 339928, UnitID = "player", Flash = true },
		{ AuraID = 358404, UnitID = "player", Flash = true },
		{ AuraID = 352917, UnitID = "player" },
		{ AuraID = 356263, UnitID = "player" },
		{ AuraID = 352875, UnitID = "player", Flash = true },

		{ AuraID = 357852, UnitID = "player" },
		{ AuraID = 356364, UnitID = "player" },
		{ AuraID = 356043, UnitID = "player" },

		{ AuraID = 60233, UnitID = "player" },
		{ AuraID = 60229, UnitID = "player" },
		{ AuraID = 60234, UnitID = "player" },

		{ AuraID = 187616, UnitID = "player" },
		{ AuraID = 187617, UnitID = "player" },
		{ AuraID = 187618, UnitID = "player" },
		{ AuraID = 187619, UnitID = "player" },
		{ AuraID = 187620, UnitID = "player" },

		{ AuraID = 201405, UnitID = "player" },
		{ AuraID = 201408, UnitID = "player" },
		{ AuraID = 201410, UnitID = "player" },
		{ AuraID = 202052, UnitID = "player", Value = true },
	},
	["Raid Buff"] = {
		{ AuraID = 54861, UnitID = "player" },

		{ AuraID = 2825, UnitID = "player" },
		{ AuraID = 32182, UnitID = "player" },
		{ AuraID = 80353, UnitID = "player" },
		{ AuraID = 264667, UnitID = "player" },
		{ AuraID = 390386, UnitID = "player" },
		{ AuraID = 363534, UnitID = "player" },
		{ AuraID = 357170, UnitID = "player" },
		{ AuraID = 178207, UnitID = "player" },
		{ AuraID = 230935, UnitID = "player" },
		{ AuraID = 256740, UnitID = "player" },
		{ AuraID = 309658, UnitID = "player" },
		{ AuraID = 102364, UnitID = "player" },
		{ AuraID = 292686, UnitID = "player" },

		{ AuraID = 1022, UnitID = "player" },
		{ AuraID = 6940, UnitID = "player" },
		{ AuraID = 1044, UnitID = "player" },
		{ AuraID = 10060, UnitID = "player" },
		{ AuraID = 77761, UnitID = "player" },
		{ AuraID = 77764, UnitID = "player" },
		{ AuraID = 31821, UnitID = "player" },
		{ AuraID = 97463, UnitID = "player" },
		{ AuraID = 64843, UnitID = "player" },
		{ AuraID = 64901, UnitID = "player" },
		{ AuraID = 81782, UnitID = "player" },
		{ AuraID = 29166, UnitID = "player" },
		{ AuraID = 47788, UnitID = "player" },
		{ AuraID = 33206, UnitID = "player" },
		{ AuraID = 53563, UnitID = "player" },
		{ AuraID = 98007, UnitID = "player" },
		{ AuraID = 223658, UnitID = "player" },
		{ AuraID = 115310, UnitID = "player" },
		{ AuraID = 116849, UnitID = "player" },
		{ AuraID = 204018, UnitID = "player" },
		{ AuraID = 102342, UnitID = "player" },
		{ AuraID = 145629, UnitID = "player" },
		{ AuraID = 156910, UnitID = "player" },
		{ AuraID = 192082, UnitID = "player" },
		{ AuraID = 201633, UnitID = "player" },
		{ AuraID = 207498, UnitID = "player" },
		{ AuraID = 238698, UnitID = "player" },
		{ AuraID = 209426, UnitID = "player" },
		{ AuraID = 374227, UnitID = "player" },
		{ AuraID = 114018, UnitID = "player", Flash = true },
		{ AuraID = 115834, UnitID = "player", Flash = true },
	},
	["Raid Debuff"] = {

		{ AuraID = 311390, UnitID = "player" },
		{ AuraID = 306583, UnitID = "player" },
		{ AuraID = 313698, UnitID = "player", Flash = true },

		{ AuraID = 366288, UnitID = "player" },
		{ AuraID = 368239, UnitID = "player", Flash = true, Text = "CD" },
		{ AuraID = 368240, UnitID = "player", Flash = true, Text = L["Haste"] },
		{ AuraID = 368241, UnitID = "player", Flash = true, Text = L["Speed"] },
		{ AuraID = 358777, UnitID = "player" },
		{ AuraID = 355732, UnitID = "player" },
		{ AuraID = 356667, UnitID = "player" },
		{ AuraID = 356925, UnitID = "player" },
		{ AuraID = 342466, UnitID = "player" },
		{ AuraID = 209858, UnitID = "player" },
		{ AuraID = 240559, UnitID = "player" },
		{ AuraID = 340880, UnitID = "player" },
		{ AuraID = 226512, UnitID = "player", Flash = true },
		{ AuraID = 240447, UnitID = "player", Flash = true },
		{ AuraID = 240443, UnitID = "player", Flash = true },

		{ AuraID = 327107, UnitID = "player" },
		{ AuraID = 340433, UnitID = "player" },
		{ AuraID = 324092, UnitID = "player", Flash = true },
		{ AuraID = 328737, UnitID = "player", Flash = true },
		{ AuraID = 326891, UnitID = "player", Flash = true },
		{ AuraID = 319603, UnitID = "player", Flash = true },
		{ AuraID = 333299, UnitID = "player" },
		{ AuraID = 319637, UnitID = "player" },
		{ AuraID = 330725, UnitID = "player", Flash = true },
		{ AuraID = 336258, UnitID = "player", Flash = true },
		{ AuraID = 331399, UnitID = "player" },
		{ AuraID = 333353, UnitID = "player" },
		{ AuraID = 327401, UnitID = "player", Flash = true },
		{ AuraID = 323471, UnitID = "player", Flash = true },
		{ AuraID = 328181, UnitID = "player" },
		{ AuraID = 327397, UnitID = "player" },
		{ AuraID = 322681, UnitID = "player" },
		{ AuraID = 335161, UnitID = "player" },
		{ AuraID = 345323, UnitID = "player", Flash = true },
		{ AuraID = 320366, UnitID = "player", Flash = true },
		{ AuraID = 322746, UnitID = "player" },
		{ AuraID = 323692, UnitID = "player" },
		{ AuraID = 331379, UnitID = "player" },
		{ AuraID = 320786, UnitID = "player" },
		{ AuraID = 323687, UnitID = "player", Flash = true },
		{ AuraID = 327893, UnitID = "player", Flash = true },
		{ AuraID = 339978, UnitID = "player", Flash = true },
		{ AuraID = 323569, UnitID = "player", Flash = true },
		{ AuraID = 334496, UnitID = "player", Stack = 7, Flash = true },
		{ AuraID = 328453, UnitID = "player" },
		{ AuraID = 335805, UnitID = "player", Flash = true },
		{ AuraID = 325027, UnitID = "player", Flash = true },
		{ AuraID = 356011, UnitID = "player" },
		{ AuraID = 353421, UnitID = "player" },
		{ AuraID = 347949, UnitID = "player", Flash = true },
		{ AuraID = 355915, UnitID = "player" },
		{ AuraID = 347771, UnitID = "player" },
		{ AuraID = 346962, UnitID = "player", Flash = true },
		{ AuraID = 348567, UnitID = "player" },
		{ AuraID = 349627, UnitID = "player" },
		{ AuraID = 350010, UnitID = "player", Flash = true },
		{ AuraID = 346828, UnitID = "player", Flash = true },
		{ AuraID = 355581, UnitID = "player", Flash = true },
		{ AuraID = 346961, UnitID = "player", Flash = true },
		{ AuraID = 347481, UnitID = "player" },
		{ AuraID = 350013, UnitID = "player" },
		{ AuraID = 350885, UnitID = "player" },
		{ AuraID = 350804, UnitID = "player" },
		{ AuraID = 349999, UnitID = "player" },
		{ AuraID = 357042, UnitID = "player" },
		{ AuraID = 359019, UnitID = "player", Flash = true },
		{ AuraID = 173324, UnitID = "player", Flash = true },
		{ AuraID = 172963, UnitID = "player", Flash = true },
		{ AuraID = 160681, UnitID = "player", Flash = true },
		{ AuraID = 166676, UnitID = "player", Flash = true },
		{ AuraID = 291937, UnitID = "player", Flash = true },
		{ AuraID = 230087, UnitID = "player", Flash = true },
		{ AuraID = 228993, UnitID = "player", Flash = true },
		{ AuraID = 228331, UnitID = "player", Flash = true },
		{ AuraID = 227480, UnitID = "player", Flash = true },

		{ AuraID = 342077, UnitID = "player" },
		{ AuraID = 329725, UnitID = "player" },
		{ AuraID = 329298, UnitID = "player" },
		{ AuraID = 325936, UnitID = "player" },
		{ AuraID = 346035, UnitID = "player" },
		{ AuraID = 331636, UnitID = "player", Flash = true },
		{ AuraID = 335293, UnitID = "player" },
		{ AuraID = 333913, UnitID = "player" },
		{ AuraID = 327039, UnitID = "player" },
		{ AuraID = 344655, UnitID = "player" },
		{ AuraID = 327089, UnitID = "player" },
		{ AuraID = 327796, UnitID = "player" },
		{ AuraID = 347283, UnitID = "player" },
		{ AuraID = 347286, UnitID = "player" },
		{ AuraID = 360403, UnitID = "player" },
		{ AuraID = 361751, UnitID = "player", Flash = true },
	},
	["Warning"] = {
		{ AuraID = 355596, UnitID = "target", Flash = true },

		{ AuraID = 304975, UnitID = "target", Value = true },
		{ AuraID = 319643, UnitID = "target", Value = true },

		{ AuraID = 226510, UnitID = "target" },
		{ AuraID = 343502, UnitID = "target" },
		{ AuraID = 373724, UnitID = "target", Value = true },

		{ AuraID = 321754, UnitID = "target", Value = true },
		{ AuraID = 343470, UnitID = "target", Value = true },
		{ AuraID = 328351, UnitID = "target", Flash = true },
		{ AuraID = 322773, UnitID = "target", Value = true },
		{ AuraID = 333227, UnitID = "target", Flash = true },
		{ AuraID = 228626, UnitID = "target" },
		{ AuraID = 324010, UnitID = "target" },
		{ AuraID = 320132, UnitID = "target" },
		{ AuraID = 320293, UnitID = "target", Value = true },
		{ AuraID = 331275, UnitID = "target", Flash = true },
		{ AuraID = 336449, UnitID = "target" },
		{ AuraID = 336451, UnitID = "target" },
		{ AuraID = 333737, UnitID = "target" },
		{ AuraID = 328175, UnitID = "target" },
		{ AuraID = 321368, UnitID = "target", Value = true },
		{ AuraID = 327416, UnitID = "target", Value = true },
		{ AuraID = 345561, UnitID = "target", Value = true },
		{ AuraID = 339917, UnitID = "target", Value = true },
		{ AuraID = 323878, UnitID = "target", Flash = true },
		{ AuraID = 317936, UnitID = "target" },
		{ AuraID = 327812, UnitID = "target" },
		{ AuraID = 323149, UnitID = "target" },
		{ AuraID = 340191, UnitID = "target", Value = true },
		{ AuraID = 323059, UnitID = "target", Flash = true },
		{ AuraID = 336499, UnitID = "target" },
		{ AuraID = 322569, UnitID = "target" },
		{ AuraID = 326771, UnitID = "target" },
		{ AuraID = 326450, UnitID = "target" },
		{ AuraID = 322433, UnitID = "target" },
		{ AuraID = 321402, UnitID = "target" },
		{ AuraID = 355640, UnitID = "target" },
		{ AuraID = 355782, UnitID = "target" },
		{ AuraID = 351086, UnitID = "target" },
		{ AuraID = 347840, UnitID = "target" },
		{ AuraID = 347992, UnitID = "target" },
		{ AuraID = 347840, UnitID = "target" },
		{ AuraID = 347015, UnitID = "target", Flash = true },
		{ AuraID = 355934, UnitID = "target", Value = true },
		{ AuraID = 349933, UnitID = "target", Flash = true, Value = true },
		{ AuraID = 229495, UnitID = "target" },
		{ AuraID = 227548, UnitID = "target", Value = true },
		{ AuraID = 227817, UnitID = "target", Value = true },
		{ AuraID = 163689, UnitID = "target", Value = true, Flash = true },

		{ AuraID = 345902, UnitID = "target" },
		{ AuraID = 334695, UnitID = "target" },
		{ AuraID = 346792, UnitID = "target" },
		{ AuraID = 331314, UnitID = "target" },
		{ AuraID = 341250, UnitID = "target" },
		{ AuraID = 329636, UnitID = "target", Flash = true },
		{ AuraID = 329808, UnitID = "target", Flash = true },
		{ AuraID = 350857, UnitID = "target", Flash = true },
		{ AuraID = 367573, UnitID = "target", Flash = true },
		{ AuraID = 368684, UnitID = "target", Value = true },
		{ AuraID = 361651, UnitID = "target", Value = true },
		{ AuraID = 362505, UnitID = "target", Flash = true },

		{ AuraID = 498, UnitID = "target" },
		{ AuraID = 642, UnitID = "target" },
		{ AuraID = 871, UnitID = "target" },
		{ AuraID = 5277, UnitID = "target" },
		{ AuraID = 1044, UnitID = "target" },
		{ AuraID = 6940, UnitID = "target" },
		{ AuraID = 1022, UnitID = "target" },
		{ AuraID = 19574, UnitID = "target" },
		{ AuraID = 23920, UnitID = "target" },
		{ AuraID = 31884, UnitID = "target" },
		{ AuraID = 33206, UnitID = "target" },
		{ AuraID = 45438, UnitID = "target" },
		{ AuraID = 47585, UnitID = "target" },
		{ AuraID = 47788, UnitID = "target" },
		{ AuraID = 48792, UnitID = "target" },
		{ AuraID = 48707, UnitID = "target" },
		{ AuraID = 61336, UnitID = "target" },
		{ AuraID = 197690, UnitID = "target" },
		{ AuraID = 147833, UnitID = "target" },
		{ AuraID = 186265, UnitID = "target" },
		{ AuraID = 113862, UnitID = "target" },
		{ AuraID = 118038, UnitID = "target" },
		{ AuraID = 114050, UnitID = "target" },
		{ AuraID = 114051, UnitID = "target" },
		{ AuraID = 114052, UnitID = "target" },
		{ AuraID = 204018, UnitID = "target" },
		{ AuraID = 205191, UnitID = "target" },
		{ AuraID = 104773, UnitID = "target" },
		{ AuraID = 199754, UnitID = "target" },
		{ AuraID = 120954, UnitID = "target" },
		{ AuraID = 122278, UnitID = "target" },
		{ AuraID = 122783, UnitID = "target" },
		{ AuraID = 188499, UnitID = "target" },
		{ AuraID = 210152, UnitID = "target" },
		{ AuraID = 247938, UnitID = "target" },
		{ AuraID = 212800, UnitID = "target" },
		{ AuraID = 162264, UnitID = "target" },
		{ AuraID = 187827, UnitID = "target" },
		{ AuraID = 125174, UnitID = "target" },
		{ AuraID = 171607, UnitID = "target" },
		{ AuraID = 228323, UnitID = "target", Value = true },
	},
	["InternalCD"] = {
		{ IntID = 240447, Duration = 20 },
		{ IntID = 352875, Duration = 30 },
		{ IntID = 114018, Duration = 15, OnSuccess = true, UnitID = "all" },
		{ IntID = 316958, Duration = 30, OnSuccess = true, UnitID = "all" },
		{ IntID = 327811, Duration = 19, OnSuccess = true, UnitID = "all" },
		{ IntID = 353635, Duration = 27.5, OnSuccess = true, UnitID = "all" },
	},
}

Module:AddNewAuraWatch("ALL", list)
